import { GraphQLNamedType } from "graphql";
import { MetadataConfig, Metadata } from "./Metadata";
import { Instantiator } from "../types";
export interface DefinitionMetadataConfig extends MetadataConfig {
    typeName?: string;
    description?: string;
}
/**
 * Contain configs required to build named GraphQL types.
 * Guarantee its type instance only created once.
 */
export declare class DefinitionMetadata<TConfig extends DefinitionMetadataConfig = DefinitionMetadataConfig> extends Metadata<TConfig> {
    readonly typeName: string;
    readonly description: string | undefined;
    /**
     * Build GraphQLType instance from metadata.
     */
    readonly typeInstance: GraphQLNamedType;
    readonly instantiate: Instantiator;
}
