"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Metadata_1 = require("./Metadata");
var types_1 = require("../types");
/**
 * Contain configs required to build named GraphQL types.
 * Guarantee its type instance only created once.
 */
var DefinitionMetadata = /** @class */ (function (_super) {
    __extends(DefinitionMetadata, _super);
    function DefinitionMetadata() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DefinitionMetadata.prototype, "typeName", {
        get: function () {
            var definitionClass = this.definitionClass;
            return this.config.typeName || definitionClass.typeName || definitionClass.name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefinitionMetadata.prototype, "description", {
        get: function () {
            return this.config.description || this.definitionClass.description;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefinitionMetadata.prototype, "typeInstance", {
        /**
         * Build GraphQLType instance from metadata.
         */
        get: function () {
            throw new Error("Should implement typeInstance getter in " + this.constructor.name);
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DefinitionMetadata.prototype, "instantiate", {
        get: function () {
            return types_1.defaultInstantiator;
        },
        enumerable: true,
        configurable: true
    });
    return DefinitionMetadata;
}(Metadata_1.Metadata));
exports.DefinitionMetadata = DefinitionMetadata;
//# sourceMappingURL=DefinitionMetadata.js.map