import { MetadataConfig, Metadata } from "./Metadata";
import { GraphQLType } from "graphql";
import { TypeExpression } from '../type-expression/TypeExpression';
import { Instantiator } from "../types";
export interface GenericMetadataConfig extends MetadataConfig {
    typeExpression: TypeExpression;
    description?: string;
}
/**
 * Contain [[TypeExpression]] object which is a reference to a GraphQL definition.
 * Resolve [[TypeExpression]]'s target instance with [[MetadataStorage]].
 */
export declare class GenericMetadata<TConfig extends GenericMetadataConfig = GenericMetadataConfig> extends Metadata<TConfig> {
    /**
     * The target GraphQLType instance.
     */
    readonly type: GraphQLType;
    /**
     * The function to instantiate this target definition class.
     */
    readonly instantiate: Instantiator;
}
