"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Metadata_1 = require("./Metadata");
/**
 * Contain [[TypeExpression]] object which is a reference to a GraphQL definition.
 * Resolve [[TypeExpression]]'s target instance with [[MetadataStorage]].
 */
var GenericMetadata = /** @class */ (function (_super) {
    __extends(GenericMetadata, _super);
    function GenericMetadata() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(GenericMetadata.prototype, "type", {
        /**
         * The target GraphQLType instance.
         */
        get: function () {
            var typeExpression = this.config.typeExpression;
            var storage = this.storage;
            return typeExpression.buildTypeInstance(storage);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GenericMetadata.prototype, "instantiate", {
        /**
         * The function to instantiate this target definition class.
         */
        get: function () {
            var typeExpression = this.config.typeExpression;
            var storage = this.storage;
            return typeExpression.buildInstantiator(storage);
        },
        enumerable: true,
        configurable: true
    });
    return GenericMetadata;
}(Metadata_1.Metadata));
exports.GenericMetadata = GenericMetadata;
//# sourceMappingURL=GenericMetadata.js.map