import { MetadataStorage } from "./MetadataStorage";
import { DefinitionClass } from "../types";
export interface MetadataConfig<T = any> {
    directives?: T;
}
/**
 * Base class of all other metadata classes.
 * Registered to [[MetadataStorage]] and keep the reference of the storage where it's in.
 */
export declare abstract class Metadata<TConfig extends MetadataConfig = any> {
    readonly definitionClass: DefinitionClass;
    protected readonly config: TConfig;
    constructor(definitionClass: Function, config: TConfig);
    registerToStorage(storage: MetadataStorage): void;
    protected storage: MetadataStorage;
}
