"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DefinitionMetadata_1 = require("./base/DefinitionMetadata");
var globalMetadataStorage_1 = require("./globalMetadataStorage");
/**
 * Get a GraphQLType instance from the given storage or default
 * global metadata storage.
 * @param targetClass
 * @param options
 */
function getGraphQLType(targetClass, storage) {
    var typeMetadata = (storage || globalMetadataStorage_1.globalMetadataStorage).getDefinitionMetadata(DefinitionMetadata_1.DefinitionMetadata, targetClass);
    if (!typeMetadata) {
        throw new Error("Given class " + targetClass.name + " has no corresponding metadata");
    }
    return typeMetadata.typeInstance;
}
exports.getGraphQLType = getGraphQLType;
//# sourceMappingURL=getGraphQLType.js.map