import { GraphQLArgumentConfig } from "graphql";
import { GenericMetadataConfig, GenericMetadata } from "../base/GenericMetadata";
export interface ArgumentMetadataConfig extends GenericMetadataConfig {
    fieldName: string;
    argumentName: string;
    defaultValue?: any;
    description?: string;
}
/**
 * Metadata type for arguments
 */
export declare class ArgumentMetadata<T extends ArgumentMetadataConfig = ArgumentMetadataConfig> extends GenericMetadata<T> {
    readonly argumentName: string;
    readonly fieldName: string;
    readonly argumentConfig: GraphQLArgumentConfig;
}
