import { GraphQLFieldConfig } from "graphql";
import { ArgumentMetadata } from "./ArgumentMetadata";
import { GenericMetadata, GenericMetadataConfig } from "../base/GenericMetadata";
export interface FieldMetadataConfig extends GenericMetadataConfig {
    fieldName: string;
    description?: string;
    deprecationReason?: string;
}
/**
 * Metadata type for fields
 */
export declare class FieldMetadata<T extends FieldMetadataConfig = FieldMetadataConfig> extends GenericMetadata<T> {
    readonly fieldName: string;
    protected findArgumentMetadata(): ArgumentMetadata[];
    readonly fieldConfig: GraphQLFieldConfig<any, any, {
        [argName: string]: any;
    }>;
    protected readonly completeArguments: (args: any, context: any, info: any) => any;
    readonly resolve: (source: any, args: any, context: any, info: any) => any;
}
