import { GraphQLInputObjectType, GraphQLInputFieldConfigMap } from "graphql";
import { InputFieldMetadata } from "./InputFieldMetadata";
import { DefinitionMetadata, DefinitionMetadataConfig } from "../base/DefinitionMetadata";
import { Instantiator } from "../types";
export interface InputObjectTypeMetadataConfig extends DefinitionMetadataConfig {
}
/**
 * Metadata type for InputObjectType
 */
export declare class InputObjectTypeMetadata<T extends InputObjectTypeMetadataConfig = InputObjectTypeMetadataConfig> extends DefinitionMetadata<T> {
    protected findInputFieldMetadata(): InputFieldMetadata[];
    /**
     * Build GraphQLInterfaceType instance from metadata.
     */
    readonly typeInstance: GraphQLInputObjectType;
    protected readonly fields: GraphQLInputFieldConfigMap;
    /**
     * Get the instantiator function from definition class or return default
     */
    readonly instantiate: Instantiator;
}
