"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var InputFieldMetadata_1 = require("./InputFieldMetadata");
var DefinitionMetadata_1 = require("../base/DefinitionMetadata");
var memoize_1 = require("../utilities/memoize");
/**
 * Metadata type for InputObjectType
 */
var InputObjectTypeMetadata = /** @class */ (function (_super) {
    __extends(InputObjectTypeMetadata, _super);
    function InputObjectTypeMetadata() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InputObjectTypeMetadata.prototype.findInputFieldMetadata = function () {
        return this.storage.findGenericMetadata(InputFieldMetadata_1.InputFieldMetadata, this.definitionClass);
    };
    Object.defineProperty(InputObjectTypeMetadata.prototype, "typeInstance", {
        /**
         * Build GraphQLInterfaceType instance from metadata.
         */
        get: function () {
            var _this = this;
            var name = this.typeName;
            var fields = function () { return _this.fields; };
            var description = this.description;
            return new graphql_1.GraphQLInputObjectType({ name: name, fields: fields, description: description });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputObjectTypeMetadata.prototype, "fields", {
        get: function () {
            var inputFieldMetadata = this.findInputFieldMetadata();
            return inputFieldMetadata.reduce(function (results, metadata) {
                results[metadata.fieldName] = metadata.inputFieldConfig;
                return results;
            }, {});
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputObjectTypeMetadata.prototype, "instantiate", {
        /**
         * Get the instantiator function from definition class or return default
         */
        get: function () {
            var definitionClass = this.definitionClass;
            var inputFieldMetadata = this.findInputFieldMetadata();
            if (definitionClass.instantiate) {
                return definitionClass.instantiate.bind(definitionClass);
            }
            return function (argsObject, context, info) {
                var instance = Object.create(definitionClass.prototype);
                return inputFieldMetadata.reduce(function (results, metadata) {
                    results[metadata.fieldName] = metadata.instantiate(argsObject[metadata.fieldName]);
                    return results;
                }, instance);
            };
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        memoize_1.memoizedGetter,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], InputObjectTypeMetadata.prototype, "typeInstance", null);
    return InputObjectTypeMetadata;
}(DefinitionMetadata_1.DefinitionMetadata));
exports.InputObjectTypeMetadata = InputObjectTypeMetadata;
//# sourceMappingURL=InputObjectTypeMetadata.js.map