import { GraphQLFieldConfigMap, GraphQLTypeResolver, GraphQLInterfaceType } from "graphql";
import { DefinitionMetadata, DefinitionMetadataConfig } from "../base/DefinitionMetadata";
import { FieldMetadata } from "./FieldMetadata";
import { Instantiator } from "../types";
export interface InterfaceTypeMetadataConfig extends DefinitionMetadataConfig {
    resolveType?: GraphQLTypeResolver<any, any>;
    description?: string;
}
/**
 * Metadata type for InterfaceType
 */
export declare class InterfaceTypeMetadata<T extends InterfaceTypeMetadataConfig = InterfaceTypeMetadataConfig> extends DefinitionMetadata<T> {
    protected getFieldMetadata(): FieldMetadata[];
    readonly typeInstance: GraphQLInterfaceType;
    readonly fields: GraphQLFieldConfigMap<any, any>;
    /**
     * Get the instantiator function from definition class or return default
     */
    readonly instantiate: Instantiator;
}
