"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var DefinitionMetadata_1 = require("../base/DefinitionMetadata");
var FieldMetadata_1 = require("./FieldMetadata");
var memoize_1 = require("../utilities/memoize");
var types_1 = require("../types");
/**
 * Metadata type for InterfaceType
 */
var InterfaceTypeMetadata = /** @class */ (function (_super) {
    __extends(InterfaceTypeMetadata, _super);
    function InterfaceTypeMetadata() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InterfaceTypeMetadata.prototype.getFieldMetadata = function () {
        return this.storage.findGenericMetadata(FieldMetadata_1.FieldMetadata, this.definitionClass);
    };
    Object.defineProperty(InterfaceTypeMetadata.prototype, "typeInstance", {
        get: function () {
            var _this = this;
            var name = this.typeName;
            var description = this.description;
            var fields = function () { return _this.fields; };
            return new graphql_1.GraphQLInterfaceType({ name: name, fields: fields, description: description });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InterfaceTypeMetadata.prototype, "fields", {
        get: function () {
            var fieldMetadata = this.getFieldMetadata();
            return fieldMetadata.reduce(function (results, metadata) {
                results[metadata.fieldName] = metadata.fieldConfig;
                return results;
            }, {});
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InterfaceTypeMetadata.prototype, "instantiate", {
        /**
         * Get the instantiator function from definition class or return default
         */
        get: function () {
            var definitionClass = this.definitionClass;
            return definitionClass.instantiate
                ? definitionClass.instantiate.bind(definitionClass)
                : types_1.defaultInstantiator;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        memoize_1.memoizedGetter,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], InterfaceTypeMetadata.prototype, "typeInstance", null);
    return InterfaceTypeMetadata;
}(DefinitionMetadata_1.DefinitionMetadata));
exports.InterfaceTypeMetadata = InterfaceTypeMetadata;
//# sourceMappingURL=InterfaceTypeMetadata.js.map