"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var DefinitionMetadata_1 = require("../base/DefinitionMetadata");
var FieldMetadata_1 = require("./FieldMetadata");
var memoize_1 = require("../utilities/memoize");
/**
 * Metadata type for ObjectType
 */
var ObjectTypeMetadata = /** @class */ (function (_super) {
    __extends(ObjectTypeMetadata, _super);
    function ObjectTypeMetadata() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ObjectTypeMetadata.prototype.getFieldMetadata = function () {
        return this.storage.findGenericMetadata(FieldMetadata_1.FieldMetadata, this.definitionClass);
    };
    ObjectTypeMetadata.prototype.fields = function () {
        var fieldMetadata = this.getFieldMetadata();
        return (fieldMetadata.reduce(function (results, metadata) {
            results[metadata.fieldName] = metadata.fieldConfig;
            return results;
        }, {}));
    };
    Object.defineProperty(ObjectTypeMetadata.prototype, "typeInstance", {
        /**
         * Build GraphQLObjectType instance from metadata.
         */
        get: function () {
            var _this = this;
            var name = this.typeName;
            var fields = function () { return _this.fields(); };
            var isTypeOf = this.isTypeOf.bind(this);
            var interfaces = this.interfaces;
            var description = this.description;
            return new graphql_1.GraphQLObjectType({ name: name, fields: fields, isTypeOf: isTypeOf, interfaces: interfaces, description: description });
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Default source type validator
     * @param source
     */
    ObjectTypeMetadata.prototype.isTypeOf = function (source) {
        return source instanceof this.definitionClass;
    };
    Object.defineProperty(ObjectTypeMetadata.prototype, "interfaces", {
        get: function () {
            var interfaces = this.config.interfaces;
            var storage = this.storage;
            return interfaces && interfaces.map(function (i) { return i.buildTypeInstance(storage); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObjectTypeMetadata.prototype, "instantiate", {
        /**
         * Get the instantiator function from definition class or return default
         */
        get: function () {
            var definitionClass = this.definitionClass;
            if (definitionClass.instantiate) {
                return definitionClass.instantiate.bind(definitionClass);
            }
            return function (sourceObject, context, info) {
                var instance = Object.create(definitionClass.prototype);
                return Object.assign(instance, sourceObject);
            };
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        memoize_1.memoizedGetter,
        __metadata("design:type", graphql_1.GraphQLObjectType),
        __metadata("design:paramtypes", [])
    ], ObjectTypeMetadata.prototype, "typeInstance", null);
    return ObjectTypeMetadata;
}(DefinitionMetadata_1.DefinitionMetadata));
exports.ObjectTypeMetadata = ObjectTypeMetadata;
//# sourceMappingURL=ObjectTypeMetadata.js.map