"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var globalMetadataStorage_1 = require("../globalMetadataStorage");
var ast_to_metadata_1 = require("./ast-to-metadata");
var storage = globalMetadataStorage_1.globalMetadataStorage;
/**
 * Register only generic metadata from parse result.
 * @param parseResult
 */
function AbstractDefinition(parseResult) {
    var documentNode = parseResult.documentNode, substitutionMap = parseResult.substitutionMap;
    var node = documentNode.definitions[0];
    return function (definitionClass) {
        var result = ast_to_metadata_1.createMetadataFromAST(node, definitionClass, substitutionMap);
        result.generics.forEach(function (meta) { return meta.registerToStorage(storage); });
    };
}
exports.AbstractDefinition = AbstractDefinition;
//# sourceMappingURL=AbstractDefinition.js.map