import { ObjectTypeDefinitionNode, InputObjectTypeDefinitionNode, NamedTypeNode, ListTypeNode, NonNullTypeNode, InterfaceTypeDefinitionNode, DefinitionNode } from 'graphql';
import { DefinitionClass } from '../types';
import { TypeExpression } from '../type-expression/TypeExpression';
import { TypeSubstitutionMap, MetadataFromAST } from './types';
export declare function createMetadataFromAST(node: DefinitionNode, definitionClass: DefinitionClass, substitutionMap: TypeSubstitutionMap): MetadataFromAST;
export declare function createTypeExpressionFromAST(type: NamedTypeNode | ListTypeNode | NonNullTypeNode, substitutionMap: TypeSubstitutionMap): TypeExpression;
export declare function createObjectTypeMetadataFromAST(node: ObjectTypeDefinitionNode, definitionClass: DefinitionClass, substitutionMap: TypeSubstitutionMap): MetadataFromAST;
export declare function createInterfaceTypeMetadataFromAST(node: InterfaceTypeDefinitionNode, definitionClass: DefinitionClass, substitutionMap: TypeSubstitutionMap): MetadataFromAST;
export declare function createInputObjectTypeMetadataFromAST(node: InputObjectTypeDefinitionNode, definitionClass: DefinitionClass, substitutionMap: TypeSubstitutionMap): MetadataFromAST;
