import { DefinitionClass } from '../types';
import { ASTParser } from './ast';
import { MetadataStorage } from '../base/MetadataStorage';
import { ObjectTypeMetadataConfig } from '../metadata/ObjectTypeMetadata';
import { InterfaceTypeMetadataConfig } from '../metadata/InterfaceTypeMetadata';
import { InputFieldMetadataConfig } from '../metadata/InputFieldMetadata';
import { InputObjectTypeMetadataConfig } from '../metadata/InputObjectTypeMetadata';
import { FieldMetadataConfig } from '../metadata/FieldMetadata';
import { ArgumentMetadataConfig } from '../metadata/ArgumentMetadata';
/**
 * Register definition metadata and generic metadata from its given parse result
 * @param parseResult
 */
export declare class TypeDefinition {
    protected constructor(parser: ASTParser, storage: MetadataStorage);
    protected definitionClass: DefinitionClass;
    protected storage: MetadataStorage;
    protected parser: ASTParser;
    protected handleObjectType(config: ObjectTypeMetadataConfig): void;
    protected handleInterfaceType(config: InterfaceTypeMetadataConfig): void;
    protected handleInputObjectType(config: InputObjectTypeMetadataConfig): void;
    protected handleField(config: FieldMetadataConfig): void;
    protected handleArgument(config: ArgumentMetadataConfig): void;
    protected handleInputField(config: InputFieldMetadataConfig): void;
    decorate(definitionClass: DefinitionClass): void;
    static createDecorator(parser: ASTParser, storage?: MetadataStorage): (definitionClass: DefinitionClass) => void;
}
export declare class AbstractTypeDefinition extends TypeDefinition {
    protected handleObjectType(config: ObjectTypeMetadataConfig): void;
    protected handleInterfaceType(config: InterfaceTypeMetadataConfig): void;
    protected handleInputObjectType(config: InputObjectTypeMetadataConfig): void;
}
export declare const defineType: typeof TypeDefinition["createDecorator"];
export declare const defineAbstractType: typeof AbstractTypeDefinition["createDecorator"];
