"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
/**
 * Parse GraphQL SDL and pick type references into [[TypeSubstitutionMap]].
 * @param strings GraphQL SDL strings to parse
 * @param typeArgs
 */
function gql(strings) {
    var typeArgs = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        typeArgs[_i - 1] = arguments[_i];
    }
    var result = [];
    var substitution_prefix = '__girin__intermediate__';
    result.push(strings[0]);
    for (var i = 0; i < strings.length - 1; i++) {
        result.push("" + substitution_prefix + i);
        result.push(strings[i + 1]);
    }
    return {
        documentNode: graphql_1.parse(result.join('')),
        substitutionMap: typeArgs.reduce(function (results, exp, i) {
            var name = "" + substitution_prefix + i;
            results[name] = exp;
            return results;
        }, {}),
    };
}
exports.gql = gql;
//# sourceMappingURL=gql.js.map