import { GraphQLType } from "graphql";
import { MetadataStorage } from "../base/MetadataStorage";
import { Lazy, Instantiator } from "../types";
import { DefinitionMetadata } from "../base/DefinitionMetadata";
export declare type TypeArg = GraphQLType | string | Function;
/**
 * Contain an argument which can be resolved to GraphQLType instance.
 * Find a instantiator from associated class instance or return default instantiator
 */
export declare class TypeExpression {
    protected options: TypeArg | Lazy<TypeArg>;
    constructor(typeArg: TypeArg | Lazy<TypeArg>);
    private getCompleteTypeArg();
    typeArg: TypeArg | Lazy<TypeArg>;
    resolveDefinitionMetadata(storage: MetadataStorage): DefinitionMetadata;
    buildInstantiator(storage: MetadataStorage): Instantiator;
    buildTypeInstance(storage: MetadataStorage): GraphQLType;
}
