import { GraphQLResolveInfo } from "graphql";
export interface DefinitionClass extends Function {
    typeName?: string;
    description?: string;
    instantiate?: Instantiator;
}
export declare type Instantiator = {
    (value: any, context?: any, info?: GraphQLResolveInfo): any;
};
export declare const defaultInstantiator: Instantiator;
export declare type ResolvedValue<T> = T | Promise<T>;
export declare type ResolvedList<T> = T[] | Promise<T[]> | Promise<T>[];
export declare type Lazy<T> = (...args: any[]) => T;
export declare function isLazy<T>(arg: Lazy<T> | any): arg is Lazy<T>;
export declare function isSubClassOf(cls: Function, superClass: Function): boolean;
export interface ConcreteClass<T> {
    new (...args: any[]): T;
}
export declare type TypedClassDecorator<T extends Function> = (cls: T) => T | void;
export declare function isPromise<T>(value: T | Promise<T>): value is Promise<T>;
