"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var memoizedBuildMap = new Map();
function memoizedGetter(target, name, descriptor) {
    var innerGetter = descriptor.get;
    return {
        get: function () {
            var buildMap = memoizedBuildMap.get(this);
            if (!buildMap) {
                buildMap = {};
                memoizedBuildMap.set(this, buildMap);
            }
            var memoized = buildMap[name];
            if (!memoized) {
                memoized = innerGetter.apply(this);
                buildMap[name] = memoized;
            }
            return memoized;
        }
    };
}
exports.memoizedGetter = memoizedGetter;
//# sourceMappingURL=memoize.js.map